
import { Webcomponent } from "./webcomponent.js";

const config = {
    item: ".tab-item",
    content: ".tab-content",
    activeClass: "ui-tab-active",
};

class UiTabs extends Webcomponent {
    constructor(parameters) {
        super();

        this.init();
    }

    init() {
        window.addEventListener("hashchange", this.hashChange.bind(this), false);

        //this.querySelectorAll(config.item).forEach(ele => ele.addEventListener("click", this.clickTab.bind(this)));

        if (window.location.hash) {
            let eve = new Event("click");
            eve.newURL = window.location.hash;
            this.hashChange(eve);
        }
    }

    hashChange(e) {
        let anchor = e.newURL.split('#')[1];

        document.querySelectorAll("#" + anchor + config.content).forEach(function(content) {
            content.parentNode.querySelectorAll(config.content + "." + config.activeClass).forEach(ele => ele.classList.remove(config.activeClass));
            content.classList.add(config.activeClass);
        });

        let element = this.querySelector("." + config.activeClass);
        element ? element.classList.remove(config.activeClass) : null;

        element = this.querySelector(config.item + `[href="#${anchor}"]`);
        element ? element.closest('div').classList.add(config.activeClass) : null;
    }

    clickTab(e) {
        e.preventDefault();
        history.pushState(null, null, this.getAttribute('href'));
    }
}

export { UiTabs }
