
class Webcomponent extends HTMLElement {

    fetch_template() {
        this.attachShadow({mode: 'open'}).appendChild(
            document.querySelector("template#" + this.tagName.toLowerCase()).content.cloneNode(true)
        );
    }

    get_name() {
        return Object.getPrototypeOf(this).constructor.name;
    }

    get_slot(name) {
        return this.querySelector('[slot="' + name + '"]');
    }

    empty_element(element) {
        while (element.lastChild) {
            element.removeChild(element.lastChild);
        }

        return element;
    }

    build_url(url, data) {
        return url + ( Object.entries(data).length ? "?" + Object.keys(data).map(function(key) {
            return [key, data[key]].map(encodeURIComponent).join("=");
        }).join("&") : "" );
    }
}

export { Webcomponent };
